int scan_reseaux() { // rempli SpotWiFi des SSID des reseaux ouverts
  // renvoi leur nombre
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);
  // WiFi.scanNetworks will return the number of networks found
  int n = WiFi.scanNetworks();
  Serial.println("scan done");
  if (n == 0) {
    Serial.println("no networks found");
    return 0;
  } else {
    Serial.print(n);
    Serial.println(" networks found");
    int j = 0; // nbr de spot ouvert
    for (int i = 0; i < n; ++i) {
      // Print SSID and RSSI for each network found
      //Serial.print(i + 1);
      //Serial.print(": ");
      //Serial.print(WiFi.SSID(i));
      //Serial.print(" (");
      //Serial.print(WiFi.RSSI(i));
      //Serial.print(")");
      //Serial.println((WiFi.encryptionType(i) == ENC_TYPE_NONE) ? " " : "<==");
      if (WiFi.encryptionType(i) == ENC_TYPE_NONE) {
        int str_len = WiFi.SSID(i).length() + 1;
        WiFi.SSID(i).toCharArray(SpotWiFi[j++], str_len);
        Serial.println(WiFi.SSID(i));
        //tickled();
      }
      delay(10);
    }
    return j;
  }
  //Serial.println("");
}

String heure_ntp() {
  int j = scan_reseaux();
  Serial.println(j);
  if (j != 0) {
    delay(200);
    WiFi.disconnect();
    delay(200);
    WiFi.mode(WIFI_STA);
    delay(200);
    for (int i = 0; i < j; i++) {
      Serial.print(SpotWiFi[i]);
      String test = SpotWiFi[i];
      if (test == "NETGEAR_EXT") continue;//?SFR WiFi FON
      if (test == "orange") continue;
      WiFi.begin(SpotWiFi[i]);
      delay(500);
      essai_connexion = 0;
      while ( WiFi.status() != WL_CONNECTED ) {
        Serial.print(".");
        //tickled;
        if (essai_connexion++ >= 5) continue;
        delay(1000);
      }
      if (WiFi.status() == WL_CONNECTED ) {
        delay(500);
        Serial.println(WiFi.localIP());
        Serial.println(WiFi.gatewayIP());
        delay(200);
        Udp.begin(localPort);
        delay(100);
        timeServer = WiFi.gatewayIP();
        //setSyncInterval(1200);
        setSyncProvider(getNtpTime);
        //tickled();
        time_t prevDisplay = 0;
        if (timeStatus() != timeNotSet) {
          if (now() != prevDisplay) { //update the display only if time has changed
            prevDisplay = now();
            Udp.stop();
            WiFi.disconnect();
            return DonneDate();
          }
        }
      }
      Serial.println("-");
      WiFi.disconnect();
      delay(500);
    }
    Serial.printf("\n");
    WiFi.disconnect();
    delay(500);
  }
}
const int NTP_PACKET_SIZ = 48; // NTP time is in the first 48 bytes of message
byte packetBuffer[NTP_PACKET_SIZ]; //buffer to hold incoming & outgoing packets

time_t getNtpTime()
{
  while (Udp.parsePacket() > 0) ; // discard any previously received packets
  delay(200);
  for (int i = 0; i <= 5; i++) {
    //Serial.println("Transmit NTP Request");
    sendNTPpacket(timeServer);
    uint32_t beginWait = millis();
    while (millis() - beginWait < 1500) {
      int size = Udp.parsePacket();
      if (size >= NTP_PACKET_SIZ) {
        //Serial.println("Receive NTP Response");
        Udp.read(packetBuffer, NTP_PACKET_SIZ);  // read packet into the buffer
        unsigned long secsSince1900;
        // convert four bytes starting at location 40 to a long integer
        secsSince1900 =  (unsigned long)packetBuffer[40] << 24;
        secsSince1900 |= (unsigned long)packetBuffer[41] << 16;
        secsSince1900 |= (unsigned long)packetBuffer[42] << 8;
        secsSince1900 |= (unsigned long)packetBuffer[43];
        return secsSince1900 - 2208988800UL + timeZone * SECS_PER_HOUR;
      }
      delay(500);
    }
  }
  //Serial.println("No NTP Response :-(");
  return 0; // return 0 if unable to get the time
}

// send an NTP request to the time server at the given address
void sendNTPpacket(IPAddress &address)
{
  // set all bytes in the buffer to 0
  memset(packetBuffer, 0, NTP_PACKET_SIZ);
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12]  = 49;
  packetBuffer[13]  = 0x4E;
  packetBuffer[14]  = 49;
  packetBuffer[15]  = 52;
  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp:
  Udp.beginPacket(address, 123); //NTP requests are to port 123
  Udp.write(packetBuffer, NTP_PACKET_SIZ);
  Udp.endPacket();
}
